#ifndef MODEL_SELECT_H
#define MODEL_SELECT_H

#include <QMainWindow>
#include <QTcpServer>
#include <QTcpSocket>
#include <QLabel>
#include <QFile>
#include "code/tree/tree_model_set.h"

namespace Ui {
class model_select;
}

class model_select : public QMainWindow
{
    Q_OBJECT

public:
    explicit model_select(QWidget *parent = nullptr);
    ~model_select();
    void setTreeModel(tree_model_set *model);//设置树形模型
signals:
    void treeItemClicked(const QModelIndex &index);//树形控件点击信号

    void receive_msg(const QString &data);  // 声明信号
private slots:
    void connectClient(QTcpSocket *clientSocket);
    void receive_Client(QTcpSocket *clientSocket);
    void on_setListen_clicked();
    void initsetting();
    void handleTreeItemClicked(const QModelIndex &index);//槽函数，处理树形控件点击事件
    void setTree_init();
    void openSimulinkModel(const QString &modelName);
    void on_btn_pause_clicked();

private:
    Ui::model_select *ui;
    tree_model_set *treeModel; //树形模型
    QTcpServer* ms;
    QTcpSocket* mtcp;
    QLabel* mstatus;
    QMap<QTcpSocket*, QString> connectedClients;
    int connectNum;
    QString sim_time_wt;
    void cbo_select_Init();
    void cbo_select_changed(int index);
    void cbo_wt_changed(int index);
    void file_write(QString *prs_name, QString *msg);
    void file_read();
    void cbo_condition_changed(int index);
    

};

#endif // MODEL_SELECT_H
