#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QStandardItemModel>
#include "code/tcp/tcp.h"
#include "code/set/set.h"
#include "code/scope/scope.h"
#include "code/tree/tree_model_set.h"
#include "code/chart/chart_file.h"
#include "code/model_select/model_select.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);

    ~MainWindow();

    // 在 MainWindow 类的头文件中（mainwindow.h）
// public slots:
//     void onTreeItemClicked(const QModelIndex &index);

private slots:
    void on_btn_link_clicked();

     void onTreeItemClicked(const QModelIndex &index);

    void on_tbtn_link_clicked();

    void on_btn_set_clicked();

    void on_tbtn_set_clicked();

    void on_btn_scope_clicked();

    void on_tbtn_scope_clicked();
    
    void tree_connect();

private:
    Ui::MainWindow *ui;
    tree_model_set treeModel; // 创建 tree_model_set 实例
    tcp page_tcp;
    scope page_scope;
    set page_set;
    chart_file page_chart;
    model_select page_model;

};
#endif // MAINWINDOW_H
